#coding: utf-8

import datetime
from uuid import uuid4
import random as rnd
import string

AO_LEVELS = (1, 2, 3, 4, 5, 6, 7, 8, 9, 70, 71)
ACT_STATUSES = (1, 10, 20, 21, 30, 31, 40, 41, 42, 43, 50, 51, 60, 61, 70)

gen_guid = (lambda: unicode(uuid4()))
gen_string = (lambda n: ''.join([rnd.choice(string.hexdigits) for i in xrange(rnd.randint(1, n))]))
gen_date = (lambda: datetime.date(rnd.randint(2000, 2014), rnd.randint(1, 12), rnd.randint(1, 28)))

def mock_ao_dict(fixed=None):
    # FIXME: сделать генерацию по схеме записи
    # FIXME: добить необязательными параметрами

    update_date = gen_date()

    ao = {
        'AOID': gen_guid(),
        'AOGUID': gen_guid(),
        'FORMALNAME': gen_string(120),
        'REGIONCODE': rnd.randint(1, 99),
        'AUTOCODE': rnd.randint(1, 9),
        'AREACODE': rnd.randint(1, 999),
        'CITYCODE': rnd.randint(1, 999),
        'CTARCODE': rnd.randint(1, 999),
        'PLACECODE': rnd.randint(1, 999),
        'STREETCODE': rnd.randint(1, 9999),
        'EXTRCODE': rnd.randint(1, 9999),
        'SEXTCODE': rnd.randint(1, 999),
        'UPDATEDATE': gen_date().strftime('%Y-%m-%d'),
        'SHORTNAME': gen_string(10),
        'AOLEVEL': rnd.choice(AO_LEVELS),
        'ACTSTATUS': rnd.choice(ACT_STATUSES),
        'CENSTATUS': rnd.choice([0, 1]),
        'OPERSTATUS': rnd.choice(ACT_STATUSES),
        'STARTDATE': (update_date - datetime.timedelta(365)).strftime('%Y-%m-%d'),
        'ENDDATE': (update_date + datetime.timedelta(365)).strftime('%Y-%m-%d'),
        'LIVESTATUS': 1 # работаем только с актуальными записями
    }

    if fixed:
        ao.update(fixed)

    return ao

